package solutions.bitbadger.documents.java.jvm.integration.sqlite;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.java.jvm.integration.common.CountFunctions;
import solutions.bitbadger.documents.jvm.integration.sqlite.SQLiteDB;

import static org.junit.jupiter.api.Assertions.assertThrows;

/**
 * SQLite integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Java | Java | SQLite: Count")
public class CountIT {

    @Test
    @DisplayName("all counts all documents")
    public void all() {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.all(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    public void byFieldsNumeric() {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.byFieldsNumeric(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    public void byFieldsAlpha() {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.byFieldsAlpha(db);
        }
    }

    @Test
    @DisplayName("byContains fails")
    public void byContainsMatch() {
        try (SQLiteDB db = new SQLiteDB()) {
            assertThrows(DocumentException.class, () -> CountFunctions.byContainsMatch(db));
        }
    }

    @Test
    @DisplayName("byJsonPath fails")
    public void byJsonPathMatch() {
        try (SQLiteDB db = new SQLiteDB()) {
            assertThrows(DocumentException.class, () -> CountFunctions.byJsonPathMatch(db));
        }
    }
}
